-- Setup Variables
local bcsQuickFrame
local bcsDetailedFrame
local tempStratText = "This will be the strategy text when it is ready! I need it to be over 255 characters so I can test the splitting of the string into the chat box without triggering WoW's spam filters. When we get the real strategy text, this can be deleted and the button can use the real strategy text."
local bossCheatSheetsPlug = "Visit BossCheatSheets.com to submit/vote on strategies!"
local selectedChatID = 1
local expansionId = "6"
local zoneId
local bossId
local specId
local expansions = Expansions
local zones = Zones
local bosses = Bosses
local specializations = Specializations
local strategy_summary = StrategySummary
local strategy_summary_clean = StrategySummaryClean
local strategy_detailed = StrategyDetailed
local strategy_specialized_summary = StrategySpecializedSummary
local strategy_specialized_detailed = StrategySpecializedDetailed
local strategy_specialized_summary_clean = StrategySpecializedSummaryClean
local chatTextCleaned = ""

local postOptions = {
  "Send strategy to raid",
  "Whisper strategy to: "
  --"'Say' strategy to everyone"
}

function BossCheatSheets_Onload()

end

function BossCheatSheets_Onshow()
  createQuickHtmlFrame()
  createDetailedHtmlFrame()
end

function createQuickHtmlFrame()
  bcsQuickFrame  = CreateFrame("SimpleHTML", "BCSQuickFrame", BossCheatSheets_FramesDialog_TabPage1_ScrollFrame_ScrollChildFrame)
  bcsQuickFrame.width  = BossCheatSheets_FramesDialog_TabPage1:GetWidth() - 30
  bcsQuickFrame.height = BossCheatSheets_FramesDialog_TabPage1:GetHeight()
  bcsQuickFrame:SetSize(bcsQuickFrame.width, bcsQuickFrame.height)
  bcsQuickFrame:SetFrameStrata("HIGH")
  bcsQuickFrame:SetPoint("LEFT", BossCheatSheets_FramesDialog_TabPage1_ScrollFrame_ScrollChildFrame, "LEFT", 15, -15)
  bcsQuickFrame:SetBackdropColor(0, 0, 0, 1)
  bcsQuickFrame:SetFont('Fonts\\FRIZQT__.TTF', 11)
end

function createDetailedHtmlFrame()
  bcsDetailedFrame  = CreateFrame("SimpleHTML", "BCSDetailedFrame", BossCheatSheets_FramesDialog_TabPage2_ScrollFrame_ScrollChildFrame)
  bcsDetailedFrame.width  = BossCheatSheets_FramesDialog_TabPage1:GetWidth() - 30
  bcsDetailedFrame.height = BossCheatSheets_FramesDialog_TabPage1:GetHeight()
  bcsDetailedFrame:SetSize(bcsDetailedFrame.width, bcsDetailedFrame.height)
  bcsDetailedFrame:SetFrameStrata("HIGH")
  bcsDetailedFrame:SetPoint("LEFT", BossCheatSheets_FramesDialog_TabPage2_ScrollFrame_ScrollChildFrame, "LEFT", 15, -15)
  bcsDetailedFrame:SetBackdropColor(0, 0, 0, 1)
  bcsDetailedFrame:SetFont('Fonts\\FRIZQT__.TTF', 11)
end

-- EXPANSION DROPDOWN
function ExpansionDropDown_Menu(frame, level, menuList)
   local info = UIDropDownMenu_CreateInfo()
   for k,v in pairs(expansions) do
      info = UIDropDownMenu_CreateInfo()
      info.text = v
      info.value = k
      info.func = ExpansionDropDownOnSelect
      UIDropDownMenu_AddButton(info, level)
   end
end

function ExpansionDropDownOnSelect(self, arg1, arg2, checked)
  UIDropDownMenu_SetSelectedID(ExpansionDropDownMenuButton, self:GetID())
  expansionId = self.value

  -- load in zones into dropdown
  ZoneDropDown_Menu()
end

-- ZONE DROPDOWN
function ZoneDropDown_Menu(frame, level, menuList)
  for k,v in pairs(zones) do
    if (string.sub(k, 1, 1) == expansionId) then
      if not zoneId then
        zoneId = k
      end
      local info = UIDropDownMenu_CreateInfo()
      info.text = v
      info.value = k
      info.func = ZoneDropDownOnSelect
      UIDropDownMenu_AddButton(info, 1)
    end
  end
  if not ZoneDropDownMenuButton then
    ZoneDropDownMenuButton:SetSelectedID(1)
    ZoneDropDownMenuButton:SetText(ZoneDropDownMenuButton:GetSelectedText())
    zoneId = ZoneDropDownMenuButton:GetSelectedValue()
    BossDropDown_Menu()
  end
end

function ZoneDropDownOnSelect(self, arg1, arg2, checked)
  UIDropDownMenu_SetSelectedID(ZoneDropDownMenuButton, self:GetID())

  zoneId = self.value

  -- load boss list
  BossDropDown_Menu()
end

-- BOSS DROPDOWN
function BossDropDown_Menu(frame, level, menuList)
  for k,v in pairs(bosses) do
    if (string.find(k, zoneId .. "_", 1, true) == 1) then
      if not zoneId then
        bossId = k
      end
      local info = UIDropDownMenu_CreateInfo()
      info.text = v
      info.value = k
      info.func = BossDropDownOnSelect
      UIDropDownMenu_AddButton(info, level)
    end
  end
  if not BossDropDownMenuButton then
    BossDropDownMenuButton:SetSelectedID(1)
    bossId = BossDropDownMenuButton:GetSelectedValue()
    BossDropDownMenuButton:SetText(BossDropDownMenuButton:GetSelectedText())
  end
end

function BossDropDownOnSelect(self, arg1, arg2, checked)
  UIDropDownMenu_SetSelectedID(BossDropDownMenuButton, self:GetID())

  bossId = self.value

  SetStrategyText()
end

-- SPEC DROPDOWN
function SpecDropDown_Menu(frame, level, menuList)
  for k,v in pairs(specializations) do
      local info = UIDropDownMenu_CreateInfo()
      info.text = v
      info.value = k
      info.func = SpecDropDownOnSelect
      UIDropDownMenu_AddButton(info, level)
  end
end

function SpecDropDownOnSelect(self, arg1, arg2, checked)
	UIDropDownMenu_SetSelectedID(SpecDropDownMenuButton, self:GetID())

  specId = self.value

  SetStrategyText()
end

-- SPEC DROPDOWN
function PostDropDown_Menu(frame, level, menuList)
   local info = UIDropDownMenu_CreateInfo()
   for k,v in pairs(postOptions) do
      info = UIDropDownMenu_CreateInfo()
      info.text = v
      info.value = k
      info.func = PostDropDownOnSelect
      UIDropDownMenu_AddButton(info, level)
   end
end

function PostDropDownOnSelect(self, arg1, arg2, checked)
	
	UIDropDownMenu_SetSelectedID(PostDropDownMenuButton, self.value)
	selectedChatID = self.value

	if (self.value == 1) then
		PostActionButton:SetText("Send")
		WhisperToEditBox:Disable()		
		WhisperToEditBox:Hide()
		WhisperToEditBox:SetText("")
	elseif (self.value == 2) then
		PostActionButton:SetText("Whisper")
		WhisperToEditBox:Show()
		WhisperToEditBox:Enable()
		WhisperToEditBox:SetText("<enter name>")
		WhisperToEditBox:SetFocus()
		WhisperToEditBox:HighlightText()
	elseif (self.value == 3) then
		PostActionButton:SetText("Say")
		WhisperToEditBox:Disable()		
		WhisperToEditBox:Hide()
		WhisperToEditBox:SetText("")
	end
end

function PostActionButtonClick()
	strategy = chatTextCleaned
	lastWordIndex = 1
	nextWordIndex = 255

	postTo = "WHISPER"
	whisperName = nil
	print("selectedChatID = " .. selectedChatID)

	if (selectedChatID == 1) then
		postTo = "RAID"
	elseif (selectedChatID == 2) then
		postTo = "WHISPER"
		whisperName = WhisperToEditBox:GetText()
	elseif(selectedChatID == 3) then
		postTo = "SAY"
	end

	while (true) -- Break at word boundary before 255 chars. This is for WoW chat limits
	do
		if (nextWordIndex > string.len(strategy)) then
			nextWordIndex = string.len(strategy)
		else
			savedWordIndex = nextWordIndex --just in case no word boundaries are met
			--TODO: Add other word boundaries like period, comma, dash, quotes, etc... Maybe use a regex instead
			while (string.byte(strategy, nextWordIndex) ~= 32) --32 is a space character. Reverse until one is found (a word boundary)
			do
				if (nextWordIndex <= lastWordIndex) then
					nextWordIndex = savedWordIndex -- There were no word boundaries left. Just take what's there
					break;
				end
				nextWordIndex = nextWordIndex - 1
			end
		end
		stratChunk = string.sub(strategy, lastWordIndex, nextWordIndex)

		SendChatMessage(stratChunk, postTo, "Common", whisperName)
		lastWordIndex = nextWordIndex
		nextWordIndex = nextWordIndex + 255
		if (lastWordIndex >= string.len(strategy)) then
			break
		end
	end	
	
	SendChatMessage(bossCheatSheetsPlug, postTo, "Common", whisperName)	
end

function SetStrategyText()
  if (SpecDropDownMenuButton:GetID() == 0) then
    if not strategy_summary[expansionId .. "_" .. zoneId .. "_" .. bossId] then
      bcsQuickFrame:SetText("<html><body>" .. strategy_summary[bossId] .. "</body></html>")
      chatTextCleaned = strategy_summary_clean[bossId]
    else
      bcsQuickFrame:SetText("<html><body>No quick strategy found. Write one at bosscheatsheets.com!</body></html>")
      chatTextCleaned = ""
    end
    if not strategy_detailed[expansionId .. "_" .. zoneId .. "_" .. bossId] then
      bcsDetailedFrame:SetText("<html><body>" .. strategy_detailed[bossId] .. "</body></html>")
    else
      bcsQuickFrame:SetText("<html><body>No detailed strategy found. Write one at bosscheatsheets.com!</body></html>")
    end
  else
    if not strategy_specialized_summary[bossId .. "_" .. specId] then
      bcsQuickFrame:SetText("<html><body>" .. strategy_summary[bossId .. "_" .. specId] .. "</body></html>")
      chatTextCleaned = strategy_specialized_summary_clean[bossId]
    else
      bcsQuickFrame:SetText("<html><body>No specific strategy was found for " .. SpecDropDownMenuButton:GetSelectedText() .. ". <br />Try a more general strategy. Or write one at bosscheatsheets.com!</body></html>")
      chatTextCleaned = "No specific strategy was found for " .. SpecDropDownMenuButton:GetSelectedText() .. ". Try a more general strategy."
    end
    if not strategy_specialized_detailed[bossId .. "_" .. specId] then
      bcsDetailedFrame:SetText("<html><body>" .. strategy_detailed[bossId .. "_" .. specId] .. "</body></html>")
    else
      bcsQuickFrame:SetText("<html><body>No specific strategy was found for " .. SpecDropDownMenuButton:GetSelectedText() .. ". <br />Try a more general strategy. Or write one at bosscheatsheets.com!</body></html>")
    end
  end
end

-- Open dialog box when /bcs is entered
--TODO: Remove Chat text
SLASH_BOSSCHEATSHEETS1 = "/bcs"
SlashCmdList["BOSSCHEATSHEETS"] = function(msg, editbox)
  ShowUIPanel(BossCheatSheets)
end